#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

//#include "../unrar-module/unrar.h"
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <pwd.h>

//#include "../pixmaps/down.xpm"

#define MAXSTR 255
#define BASE_CONF_DIR "/usr/share/pixmaps/gnomerar"
#define SHARE_DIR ""
#define CONFIG_FILE "~/.gnomerar"

// My Gtk Widgets
GtkWidget *about3;
GtkWidget *open2;
GtkWidget *open3;
GtkWidget *open4;
GtkWidget *messagebox1;
GtkWidget *messagebox2;
GtkWidget *messagebox4;
GtkWidget *messagebox5;
GtkWidget *messagebox6;
GtkWidget *messagebox7;
GtkWidget *preferences2;
GtkWidget *clist1;
GtkWidget *dialog1;
GtkWidget *progressbar1;
GtkWidget *statusbar1;
GtkWidget *window1;
GtkWidget *text1;
GtkWidget *text2;
GtkWidget *entry1;
GtkWidget *entry3;
GtkWidget *entry6;
GtkWidget *dialog3;
GtkWidget *pixu;
GtkWidget *my_combo_box;
GtkWidget *combo1;
GtkWidget *window2;

FILE *rarfile;
FILE *tempfile;
FILE *viewfile;
FILE *commfile;
FILE *cfgfile;
FILE *scrfile;

int rar_ok;		// is rar installed ?
gchar *rar_result;
int opd_archive=1;
gchar *opd_archive_name;
gchar *newarchname;
gchar *test_arch_name;
gchar *newarch;
gchar *name[0x100];
char fbuffer[20];
char *mybuffer[0x200];
char *directories[0x200];
int dirnamesize=0;
int arcsize;
char *arcfile;
int viewsize;
int commsize;
char *vwfile;
char *cmmfile;
guint textlen;
gchar *mygtktext;
int line,row;
char xfrchr[0x100];
char xfrsize[0xA];
char xfrpck[0xA];
char date[9];
char attr[11];
char crc[9];
char ratio[5];
int myargc;
char *myargv[10];

char buff[0x50];
gchar *clist_line[411][8];
gchar *clist_line1[411][8];
int i,j=0,q,p;
gint context_id;

int select_all=0;
int files_selected=0;
gchar *sel_files;
int sel_rows[0x100];
int total_sel_size=0;
int total_sel_packed=0;
int last_select_row=0;
int last_unselect_row=0;
int last_select_col;
int last_unselect_col;
int implicit_sel;
int lastfilelen;
int testdbl=0;
float curprogress;
float ratioprogress;
char *directory_read=".";
char *directory_up="..";
char *rar_extension=".rar";
char lck[4]="lock";
struct stat statbuf;

DIR *reading;
struct dirent *next;

int pos1=0;
int pos2=0;
char nicexfr[0x100];
int convsfx=0;
int pathch=0;
int applych=0;
gchar sfx_path[0x100];
gchar *rar_path1;
gchar *rar_path;
gchar def_path[0x100];
int cfgsize;
gchar *vol_size;
gchar vol_command[0x20];
int my_vol_size=0;
int vol_change=0;
gchar *compression_level;
gchar *dictionary_size;
gchar comp_command[0x20];
gchar dict_command[0x20];
gchar compr;
int pass_locked_arch=0;
int create_locked_arch=0;
gchar *arch_pass;
gchar pass_command[0x30];
gchar no_pass_command[0x30]="-p-";
gchar *create_arch_pass;
gchar crt_script_file[0x100]="#!/bin/bash\n\n$1 a $2 $3 $4 $5 $6 $7";
gchar del_script_file[0x100]="#!/bin/bash\n\n$1 d $2 $3";
gchar ext_script_file[0x100]="#!/bin/bash\n\n$1 x -o+ -y $2 $3";
gchar tmp_script_file[0x100]="#!/bin/bash\n\nrm -f /tmp/.temp\n$1 v $2 > /tmp/.temp";
gchar tvi_script_file[0x100]="#!/bin/bash\n\nrm -f /tmp/.view\n$1 $2 p $3 $4 > /tmp/.view";
gchar cur_dir[0x100];
int endpos;
gchar my_path[0x100]=".gnomerar";

GdkPixmap *dirpix;
GdkBitmap *dirmask;
GdkPixmap *docpix;
GdkBitmap *docmask;
GdkPixmap *comppix;
GdkBitmap *compmask;
GdkPixmap *dotpix;
GdkBitmap *dotmask;
GdkPixmap *lockpix;
GdkBitmap *lockmask;

void
on_new_file1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
dialog1=create_dialog1();
gtk_widget_show(dialog1);
}


void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
open2=create_fileselection1();
gtk_widget_show(open2);
}

void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
remove("/tmp/.view");
remove("/tmp/.temp");
gtk_main_quit();
}


void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_clear1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_properties1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
dialog3=create_dialog3();
entry3=lookup_widget(GTK_WIDGET(dialog3),"entry3");
gtk_entry_set_text((GtkEntry*)entry3,def_path);
gtk_widget_show(dialog3);
}


void
on_about2_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
about3=create_about3();
gtk_widget_show(about3);
}


void
on_button8_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
open2=create_fileselection1();
gtk_widget_show(open2);
}


void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
curprogress=0.15;
opd_archive=0;
opd_archive_name=gtk_file_selection_get_filename (GTK_FILE_SELECTION(user_data));
memcpy((gchar*)name,opd_archive_name,0x100);
gnome_appbar_set_progress(GNOME_APPBAR(statusbar1),curprogress);
rarfile=fopen(opd_archive_name,"r");
if (rarfile!=0) {
	fread(fbuffer,4,1,rarfile);
	fclose(rarfile);
	if(strcmp(fbuffer,"Rar!")!=0) { 
				messagebox1=create_messagebox1();
				gtk_widget_show(messagebox1);
				opd_archive=1;
				gtk_widget_destroy(open2);
				return;
				}
	else if(fork()==0) execl("/tmp/grarscr","grarscr",rar_path,opd_archive_name,NULL);
	wait(0);
	curprogress=0.19;
	gnome_appbar_set_progress(GNOME_APPBAR(statusbar1),curprogress);
        gtk_clist_clear((GtkCList *)clist1);
	tempfile=fopen("/tmp/.temp","r");
        fseek(tempfile,0L,SEEK_END);
        arcsize=ftell(tempfile);
        arcfile=malloc(arcsize);
        //clist_line=(gchar **)calloc(arcsize/40,7);
        //g_print("%s",arcsize/40);
        fseek(tempfile,0L,SEEK_SET);
        fread(arcfile,arcsize,1,tempfile);
        fclose(tempfile);
        *clist_line[line]=directory_read;
	gtk_clist_append( (GtkCList *) clist1,clist_line[line]);
        *clist_line[line]=directory_up;
        gtk_clist_append( (GtkCList *) clist1,clist_line[line]);
	curprogress=0.20;
	gnome_appbar_set_progress(GNOME_APPBAR(statusbar1),curprogress);
        i=0;line=0;row=1;
        while (arcfile[i]!=0x2D || arcfile[i+1]!=0x2D) i++;
	i=i+0x50;
        while (arcfile[i]!=0x2D || arcfile[i+1]!=0x2D)
	{
	j=0;
	if (arcfile[i]=='*') {
			//gtk_clist_set_pixmap(GTK_CLIST(clist1),line,0,lockpix,lockmask);
			(gchar*)clist_line[line][2]=lck;
			pass_locked_arch=1;
			}
	*clist_line[line]=0;
	while (arcfile[i]!=0x0A)
			{
			    xfrchr[j]=arcfile[i];
			    i++;j++;
			}
	xfrchr[j]='\0';
	//*clist_line[line]=0;
	(gchar *)clist_line[line][1]=xfrchr;
	i++;
	while (arcfile[i]==0x20) i++;
        j=0;
	while (arcfile[i]!=0x20)
			{
			    xfrsize[j]=arcfile[i];
			    i++;j++;
			}
	xfrsize[j]='\0';
	(gchar *)clist_line[line][3]=xfrsize;
	while (arcfile[i]==0x20) i++;
	j=0;
	while (arcfile[i]!=0x20)
			{
			    xfrpck[j]=arcfile[i];
			    i++;j++;
			}
	xfrpck[j]='\0';
	(gchar *)clist_line[line][4]=xfrpck;		// add packsize
	while (arcfile[i]==0x20) i++;
        j=0;
	while (arcfile[i]!=0x20)
			{
			    ratio[j]=arcfile[i];
			    i++;j++;
			}
	ratio[j]='\0';
	(gchar *)clist_line[line][8]=ratio;		// add ratio
	while (arcfile[i]==0x20) i++;
	j=0;
	while (arcfile[i]!=0x20)
			{
			    date[j]=arcfile[i];
			    i++;j++;
			}
	(gchar *)clist_line[line][5]=date;		// add date
	while (arcfile[i]==0x20) i++;
	while (arcfile[i]!=0x20) i++;
	while (arcfile[i]==0x20) i++;
	j=0;
	while (arcfile[i]!=0x20)
			{
			    if (arcfile[i]=='d') {
						    p=dirnamesize+strlen(*clist_line[line]);
						    //for (q=0;q<=strlen(*clist_line[line]);q++) directories[dirnamesize+q]=*clist_line[line+q];
						    //strcpy(directories,clist_line[line]);
						    //dirnamesize+=strlen(*clist_line[line]);
						    //dirnamesize--;
						    //g_print("%s %d %s",directories,dirnamesize,*clist_line[line]);
						    }
			    attr[j]=arcfile[i];
			    i++;j++;
			}
	(gchar *)clist_line[line][6]=attr;			// add attr
	while (arcfile[i]==0x20) i++;
	j=0;
	//curprogress+=0.00;gtk_progress_bar_update((GtkProgressBar *)progressbar1,curprogress);
	while (arcfile[i]!=0x20)
			{
			    crc[j]=arcfile[i];
			    i++;j++;
			}
	(gchar *)clist_line[line][7]=crc;			// add crc sum
	gtk_clist_append( (GtkCList *) clist1,clist_line[line]);
	line++;i=i+9;
	}
	sel_files=malloc(0xFF*(line+2)+0xFF+line);
	strcpy(sel_files,(gchar *)name);
	g_snprintf(buff,50,"Total files: %d",line);
	gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
	free(arcfile);
	fbuffer[0]=0;
	gtk_widget_destroy(open2);
	j=0;
	j=j+strlen((gchar *)name);sel_files[j]=0x20;sel_files[j++]=0x20;
	implicit_sel=j;
	gnome_appbar_set_progress(GNOME_APPBAR(statusbar1),1);
	remove("/tmp/.temp");
	if (pass_locked_arch==1 && arch_pass=='\0') {
			    window2=create_window2();
			    gtk_widget_show(window2);
			    }
}
}


void
on_cancel_button1_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(open2);
}


void
on_button13_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
remove("/tmp/.temp");
remove("/tmp/.view");
gtk_main_quit();
}

void
on_button9_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
if (opd_archive!=0) {
			messagebox2=create_messagebox2();
			gtk_widget_show(messagebox2);
		    }
else {
    if (select_all==1) {
			gnome_appbar_set_progress(GNOME_APPBAR(statusbar1),0.3);
			if (fork()==0) execl(rar_path,"rar","x","-o+","-y",pass_command,name,NULL);
			gnome_appbar_set_progress(GNOME_APPBAR(statusbar1),0.7);
			wait(0);
		    }
    else {
	    if (fork()==0) execl("/tmp/grarextr","grarextr",rar_path,pass_command,sel_files,NULL);
	    wait(0);
	    gnome_appbar_set_progress(GNOME_APPBAR(statusbar1),0.9);
	    for (i=0;i<=files_selected;i++) gtk_clist_unselect_row((GtkCList *)clist1,sel_rows[i],0);
	    gnome_appbar_set_progress(GNOME_APPBAR(statusbar1),1);
	    total_sel_size=0;		// reset selected files size
	    gnome_appbar_pop(GNOME_APPBAR(statusbar1));
	}
}
}


void
on_clist1_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
if (testdbl) {
		gtk_clist_unselect_row(clist,row,0);
		gnome_appbar_pop(GNOME_APPBAR(statusbar1));
		total_sel_size=0;
		files_selected=0;
		testdbl=0;
		return;
		}
if (opd_archive==0) {
    if (row!=1 && row!=0) {
	gchar *text;
	last_select_row=row;
	last_select_col=column;
	files_selected++;
	gtk_clist_get_text(GTK_CLIST(clist),row,8,&text);
	ratioprogress=(atof(text)/100);
	gnome_appbar_set_progress(GNOME_APPBAR(statusbar1),ratioprogress);
	gtk_clist_get_text(GTK_CLIST(clist),row,3,&text);
	total_sel_size=total_sel_size+atoi(text);
	g_snprintf(buff,50,"Files selected size: %d",total_sel_size);
	if (files_selected>1) gnome_appbar_pop(GNOME_APPBAR(statusbar1));
	gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
	gtk_clist_get_text(GTK_CLIST(clist),row,1,&text);
	sel_rows[files_selected]=row;
	i=0;
	lastfilelen=j;
	while (text[i]!=0x0) {
			sel_files[j]=text[i];
			i++;j++;
			}
	sel_files[j]=0x20;
	j++;
	row=0;
	return;
	}
    else{
	if (row!=0) {
		opd_archive=1;
		gtk_clist_clear( (GtkCList *) clist1);
		remove("/tmp/.temp");
		read_pwd_files(".");
		strcpy(pass_command,no_pass_command);
		pass_locked_arch=0;
		files_selected=0;
		total_sel_size=0;
		arch_pass='\0';
		row=0;
		return;
	}
    }
    if (row==0) {
	gtk_clist_clear( (GtkCList *) clist1);
	reload_arch((char *)name);
	files_selected=0;
	memset(sel_rows,0,sizeof(sel_rows));
	gnome_appbar_pop(GNOME_APPBAR(statusbar1));
	j=implicit_sel;
	total_sel_size=0;	// reset size of selected files
	gnome_appbar_set_progress(GNOME_APPBAR(statusbar1),0);
    }
}
else {
gchar *text;
gtk_clist_get_text(GTK_CLIST(clist),row,1,&text);
strcpy(nicexfr,text);
    if (row==0) {
	    gtk_clist_clear( (GtkCList *) clist1);
	    read_pwd_files(".");
    }
    if (row!=1 && row!=0) {
		if (cmpare(nicexfr,".rar")==0){
		    if (rar_ok==0) {
				    messagebox4=create_messagebox4();
				    gtk_widget_show(messagebox4);
				    }
		    else {
			    reload_arch(nicexfr);
			    memcpy((gchar*)name,nicexfr,0x100);
			    opd_archive=0;
			    files_selected=0;
			    sel_files=malloc(0xFF*(line+2)+0xFF+line);
			    strcpy(sel_files,(gchar *)name);
			    g_snprintf(buff,50,"Total files: %d",line);
			    gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
			    fbuffer[0]=0;
			    j=0;
			    j=j+strlen((gchar *)name);sel_files[j]=0x20;sel_files[j++]=0x20;
			    implicit_sel=j;
			    }
		}
		else{
		    gtk_clist_get_text(GTK_CLIST(clist),row,1,&text);
		    if (text[0]!='d'){
					gchar *text;
					last_select_row=row;
					last_select_col=column;
					files_selected++;
					gtk_clist_get_text(GTK_CLIST(clist),row,3,&text);
					total_sel_size=total_sel_size+atoi(text);
					g_snprintf(buff,50,"Files selected size: %d",total_sel_size);
					if (files_selected>1) gnome_appbar_pop(GNOME_APPBAR(statusbar1));
					gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
					//gtk_clist_get_text(GTK_CLIST(clist),row,8,&text);
					//ratioprogress=(atof(text)/100);
					//gnome_appbar_set_progress(GNOME_APPBAR(statusbar1),ratioprogress);
					gtk_clist_get_text(GTK_CLIST(clist),row,1,&text);
					sel_rows[files_selected]=row;
					i=0;
					lastfilelen=j;
					while (text[i]!=0) {
							    sel_files[j]=text[i];
							    i++;j++;
							    }
					sel_files[j]=0x20;
					j++;
				    }
		    else{
				//gchar *text;
				last_select_row=row;
				last_select_col=column;
				files_selected++;
				sel_rows[files_selected]=row;
				i=0;
				lastfilelen=j;
				while (text[i]!=0) {
					    sel_files[j]=text[i];
					    i++;j++;
					    }
				sel_files[j]=0x20;
				j++;
				
				
		    }
		}
	}
    else {
	if (row!=0) {
	    gtk_clist_clear( (GtkCList *) clist1);
	    chdir("../");
	    read_pwd_files(".");
	    pass_locked_arch=0;
	    }
	}
}
last_select_row=row;
last_select_col=column;
}

void
on_close1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
if (opd_archive==0) {
		    opd_archive=1;
		    gtk_clist_clear( (GtkCList *) clist1);
		    remove("/tmp/.temp");
		    strcpy(pass_command,no_pass_command);
		    pass_locked_arch=0;
		    arch_pass='\0';
		    read_pwd_files(".");
		    }
}


void
on_button17_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
dialog3=create_dialog3();
entry3=lookup_widget(GTK_WIDGET(dialog3),"entry3");
gtk_entry_set_text((GtkEntry*)entry3,def_path);
gtk_widget_show(dialog3);
}


void
on_clist1_select_all                   (GtkCList        *clist,
                                        gpointer         user_data)
{
select_all=1;
}


void
on_clist1_unselect_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
gchar *text;

gtk_clist_get_text(GTK_CLIST(clist),row,3,&text);
total_sel_size=total_sel_size-atoi(text);
gnome_appbar_set_progress(GNOME_APPBAR(statusbar1),0);
g_snprintf(buff,50,"Files selected size: %d",total_sel_size);
gnome_appbar_pop(GNOME_APPBAR(statusbar1));
if (total_sel_size!=0) gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
//memset(&sel_files,0,lastfilelen);
//for (q=lastfilelen;q<j;q++) sel_files[q]=0;
last_unselect_row=row;
last_unselect_col=column;
files_selected--;
}


void
on_button7_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
dialog1=create_dialog1();
gtk_widget_show(dialog1);
}


void
on_button21_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
entry1=user_data;
newarchname=gtk_entry_get_text(GTK_ENTRY(entry1));
if (strlen(newarchname)!=0 && files_selected!=0) {
	if (cmpare(newarchname,".rar")!=0) newarchname=strcat(newarchname,".rar");
	strcpy(nicexfr,newarchname);
	if (create_locked_arch!=1) strcpy(pass_command," ");
	if (vol_change==0 || strcmp(vol_size,"Autodetect")==0) {
					if (fork()==0) execl("/tmp/grarcrt","grarcrt",rar_path,"-v",pass_command,comp_command,dict_command,nicexfr,sel_files,NULL);
					wait(0);
					free(sel_files);
					reload_arch(nicexfr);
					memcpy((gchar *)name,nicexfr,0x100);
					opd_archive=0;
					sel_files=malloc(0xFF*(line+2)+0xFF+line);
					strcpy(sel_files,(gchar *)name);
					g_snprintf(buff,50,"Total files: %d",line);
					gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
					fbuffer[0]=0;
					j=0;
					j=j+strlen((gchar *)name);sel_files[j]=0x20;sel_files[j++]=0x20;
					implicit_sel=j;
					}
	else {
		my_vol_size=atof((gchar*)vol_size);
		my_vol_size=my_vol_size;
		g_snprintf(vol_command,10,"-v%db",my_vol_size);
		if (fork()==0) execl("/tmp/grarcrt","grarcrt",rar_path,pass_command,vol_command,nicexfr,sel_files,NULL);
	}
gtk_widget_destroy(dialog1);
strcpy(pass_command,no_pass_command);
create_locked_arch=0;
vol_change=0;
}
//else {
//    if (files_selected==0) {
//			messagebox7=create_messagebox7();
//			gtk_widget_show(messagebox7);
//			}
//}
}


void
on_button22_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(dialog1);
}


void
on_clist1_unselect_all                 (GtkCList        *clist,
                                        gpointer         user_data)
{

}

void
on_app1_set_focus                      (GtkWindow       *window,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{
//progressbar1=user_data;
}

void
on_app1_destroy                        (GtkObject       *object,
                                        gpointer         user_data)
{
remove("/tmp/.temp");		// if archive is still open and didn't get close signal
remove("/tmp/.view");
gtk_main_quit();
}

void
on_app1_show                           (GtkWidget       *widget,
                                        gpointer         user_data)
{
//statusbar1=user_data;
//context_id=gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar1),"my statusbar");
//progressbar1=lookup_widget(GTK_WIDGET(widget),"progressbar1");
clist1=lookup_widget(GTK_WIDGET(widget),"clist1");
entry6=lookup_widget(GTK_WIDGET(widget),"combo_entry4");
statusbar1=lookup_widget(GTK_WIDGET(widget),"appbar1");
//gnome_app_progress_manual(widget,"aaa",0,0);
getcwd(cur_dir,0x100);
gtk_entry_set_text((GtkEntry *)entry6,cur_dir);
config_path();
if ((cfgfile=fopen(my_path,"r"))==NULL) {
				    g_snprintf(buff,70,"Configuration file not found , parsing the defaults");
				    gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
				    cfgfile=fopen(my_path,"w+");
				    strcpy(def_path,"/usr/bin");
				    fwrite(def_path,8,1,cfgfile);
				    fclose(cfgfile);
				    }
else fclose(cfgfile);
preferences2=create_dialog3();
entry3=lookup_widget(GTK_WIDGET(preferences2),"entry3");
rar_path=gtk_entry_get_text(GTK_ENTRY(entry3));
cfgfile=fopen(my_path,"r");
fseek(cfgfile,0L,SEEK_END);
cfgsize=ftell(cfgfile);
fseek(cfgfile,0L,SEEK_SET);
fread(def_path,cfgsize,1,cfgfile);
fclose(cfgfile);
strcpy(rar_path,def_path);
strcat(rar_path,"/rar");
if (fopen("/tmp/grarcrt","r")==NULL) {
				    scrfile=fopen("/tmp/grarcrt","w+");
				    fwrite(crt_script_file,strlen(crt_script_file),1,scrfile);
				    fclose(scrfile);
				    if (fork()==0) execl("/bin/chmod","chmod","a+x","/tmp/grarcrt",0);
				    wait(0);
				    }
if (fopen("/tmp/grardel","r")==NULL) {
				    scrfile=fopen("/tmp/grardel","w+");
				    fwrite(del_script_file,strlen(del_script_file),1,scrfile);
				    fclose(scrfile);
				    if (fork()==0) execl("/bin/chmod","chmod","a+x","/tmp/grardel",0);
				    wait(0);
				    }
if (fopen("/tmp/grarextr","r")==NULL) {
				    scrfile=fopen("/tmp/grarextr","w+");
				    fwrite(ext_script_file,strlen(ext_script_file),1,scrfile);
				    fclose(scrfile);
				    if (fork()==0) execl("/bin/chmod","chmod","a+x","/tmp/grarextr",0);
				    wait(0);
				    }
if (fopen("/tmp/grarscr","r")==NULL) {
				    scrfile=fopen("/tmp/grarscr","w+");
				    fwrite(tmp_script_file,strlen(tmp_script_file),1,scrfile);
				    fclose(scrfile);
				    if (fork()==0) execl("/bin/chmod","chmod","a+x","/tmp/grarscr",0);
				    wait(0);
				    }
if (fopen("/tmp/grarview","r")==NULL) {
				    scrfile=fopen("/tmp/grarview","w+");
				    fwrite(tvi_script_file,strlen(tvi_script_file),1,scrfile);
				    fclose(scrfile);
				    if (fork()==0) execl("/bin/chmod","chmod","a+x","/tmp/grarview",0);
				    wait(0);
				    }
/*Setting default dictionary size */
strcpy(dict_command,"-md");
strcat(dict_command,"256");
/*Setting default compresion method (normal)*/
strcpy(comp_command,"-m");
strcat(comp_command,"3");
/*Checking for presence of rar*/
rar_ok=check_for_rar();
read_pwd_files(".");
}

void
on_button11_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
char *text;
gtk_clist_get_text(GTK_CLIST(clist1),last_select_row,1,&text);
if (opd_archive!=0 && files_selected!=0) {
		    tempfile=fopen(text,"r");
		    fseek(tempfile,0L,SEEK_END);
		    viewsize=ftell(tempfile);
		    vwfile=malloc(viewsize);
		    fseek(tempfile,0L,SEEK_SET);
		    fread(vwfile,viewsize,1,tempfile);
		    fclose(tempfile);
		    window1=create_window1();
		    gtk_widget_show(window1);
    		    gtk_text_freeze(GTK_TEXT(text2));
		    gtk_text_insert(GTK_TEXT(text2),NULL,&text2->style->black,NULL,vwfile,viewsize);
		    gtk_text_thaw(GTK_TEXT(text2));
		    }
else {
    if (files_selected!=0) {
	    if (fork()==0) execl("/tmp/grarview","grarview",rar_path,pass_command,name,text,NULL);
	    wait(0);
	    viewfile=fopen("/tmp/.view","r");
	    fseek(viewfile,0L,SEEK_END);
	    viewsize=ftell(viewfile);
	    vwfile=malloc(viewsize);
	    fseek(viewfile,0L,SEEK_SET);
	    fread(vwfile,viewsize,1,viewfile);
	    fclose(viewfile);
	    window1=create_window1();
	    gtk_widget_show(window1);
	    gtk_text_freeze(GTK_TEXT(text2));
	    q=0;
	    while (vwfile[q]!='-' || vwfile[q+1]!='-') q++;
	    q+=16;
	    gtk_text_insert(GTK_TEXT(text2),NULL,&text2->style->black,NULL,vwfile+q,viewsize-q);
	    gtk_text_thaw(GTK_TEXT(text2));
	    remove("/tmp/.view");
	    //gtk_clist_unselect_row(GTK_CLIST(clist1),last_select_row,0);
	    //files_selected=1;
    }
}
}

void
on_window1_show                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
text2=user_data;
}


void
on_window1_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
free(vwfile);			// free my file reading buffers
}


void
on_button12_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
if (opd_archive!=0) {
			messagebox2=create_messagebox2();
			gtk_widget_show(messagebox2);
		    }
else {
	if (fork()==0) execl("/tmp/grardel","grardel",rar_path,pass_command,sel_files,NULL);
        wait(0);
	gtk_clist_clear( (GtkCList *) clist1);
	reload_arch((char *)name);
	files_selected=0;
	memset(sel_rows,0,sizeof(sel_rows));
	gnome_appbar_pop(GNOME_APPBAR(statusbar1));
	j=implicit_sel;
	total_sel_size=0;	// reset size of selected files
	gtk_progress_bar_update((GtkProgressBar *)progressbar1,0);	//reset my progress bar*/
	gnome_appbar_set_progress(GNOME_APPBAR(statusbar1),0);
	}
}


void
reload_arch(char *myname)
{
rarfile=fopen(myname,"r");
fread(fbuffer,4,1,rarfile);
fclose(rarfile);
if(strcmp(fbuffer,"Rar!")!=0) { 
				messagebox1=create_messagebox1();
				gtk_widget_show(messagebox1);
				opd_archive=1;
				}
else {if (fork()==0) execl("/tmp/grarscr","grarscr",rar_path,myname,NULL);
wait(0);
gtk_clist_clear( (GtkCList *) clist1);
memset(clist_line,0,sizeof(clist_line));
(gchar*)clist_line[line][1]=directory_read;
gtk_clist_append( (GtkCList *) clist1,clist_line[line]);
(gchar*)clist_line[line][1]=directory_up;
gtk_clist_append( (GtkCList *) clist1,clist_line[line]);
gtk_clist_set_pixmap(GTK_CLIST(clist1),1,0,dotpix,dotmask);
tempfile=fopen("/tmp/.temp","r");
fseek(tempfile,0L,SEEK_END);
arcsize=ftell(tempfile);
arcfile=malloc(arcsize);
fseek(tempfile,0L,SEEK_SET);
fread(arcfile,arcsize,1,tempfile);
fclose(tempfile);
i=0;line=0;row=1;
while (arcfile[i]!=0x2D || arcfile[i+1]!=0x2D) i++;
i=i+0x50;
while (arcfile[i]!=0x2D || arcfile[i+1]!=0x2D)
{
j=0;
if (arcfile[i]=='*') {
			//gtk_clist_set_pixmap(GTK_CLIST(clist1),line,0,lockpix,lockmask);
			(gchar*)clist_line[line][2]=lck;
			pass_locked_arch=1;
			}
*clist_line[line]=0;
while (arcfile[i]!=0x0A)
			{
			    xfrchr[j]=arcfile[i];
			    i++;j++;
			}
xfrchr[j]='\0';
(gchar*)clist_line[line][1]=xfrchr;
i++;
while (arcfile[i]==0x20) i++;
j=0;
while (arcfile[i]!=0x20)
			{
			    xfrsize[j]=arcfile[i];
			    i++;j++;
			}
xfrsize[j]='\0';
(gchar *)clist_line[line][3]=xfrsize;
while (arcfile[i]==0x20) i++;
j=0;
while (arcfile[i]!=0x20)
			{
			    xfrpck[j]=arcfile[i];
			    i++;j++;
			}
xfrpck[j]='\0';
(gchar *)clist_line[line][4]=xfrpck;		// add packsize
while (arcfile[i]==0x20) i++;
j=0;
while (arcfile[i]!=0x20)
			{
			    ratio[j]=arcfile[i];
			    i++;j++;
			}
ratio[j]='\0';
(gchar *)clist_line[line][8]=ratio;		// add ratio
while (arcfile[i]==0x20) i++;
j=0;
while (arcfile[i]!=0x20)
			{
			    date[j]=arcfile[i];
			    i++;j++;
			}
(gchar *)clist_line[line][5]=date;		// add date
while (arcfile[i]==0x20) i++;
while (arcfile[i]!=0x20) i++;
while (arcfile[i]==0x20) i++;
j=0;
while (arcfile[i]!=0x20)
			{
			    attr[j]=arcfile[i];
			    i++;j++;
			}
(gchar *)clist_line[line][6]=attr;			// add attr
while (arcfile[i]==0x20) i++;
j=0;
while (arcfile[i]!=0x20)
			{
			    crc[j]=arcfile[i];
			    i++;j++;
			}
(gchar *)clist_line[line][7]=crc;			// add crc sum
gtk_clist_append( (GtkCList *) clist1,clist_line[line]);
line++;i=i+9;
}
free(arcfile);
}
if (pass_locked_arch==1 && arch_pass=='\0') {
			    window2=create_window2();
			    gtk_widget_show(window2);
			    }
}

void
on_ok_button2_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
newarch=gtk_file_selection_get_filename(GTK_FILE_SELECTION(user_data));
gtk_entry_set_text(GTK_ENTRY(entry1),newarch);
gtk_widget_destroy(open3);
}


void
on_cancel_button2_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(open3);
gtk_window_set_title(GTK_WINDOW(user_data),"mulmu");
}


void
on_button24_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
entry1=user_data;
open3=create_fileselection2();
gtk_widget_show(open3);

}


void
on_select_all1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

int
check_for_rar(void)
{
int rar_ok=0;
strcpy(buff,rar_path);
if ((rarfile=fopen(buff,"r"))!=NULL) {rar_ok=1;fclose(rarfile);}
if (rar_ok==0) {
		messagebox4=create_messagebox4();
		gtk_widget_show(messagebox4);
		}
memset(buff,0,sizeof(buff));
return rar_ok;
}

void
on_selected_file1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
char *text;
if (opd_archive!=0 && files_selected!=0) {
		    tempfile=fopen(text,"r");
		    fseek(tempfile,0L,SEEK_END);
		    viewsize=ftell(tempfile);
		    vwfile=malloc(viewsize);
		    fseek(tempfile,0L,SEEK_SET);
		    fread(vwfile,viewsize,1,tempfile);
		    fclose(tempfile);
		    window1=create_window1();
		    gtk_widget_show(window1);
    		    gtk_text_freeze(GTK_TEXT(text2));
		    gtk_text_insert(GTK_TEXT(text2),NULL,&text2->style->black,NULL,vwfile,viewsize);
		    gtk_text_thaw(GTK_TEXT(text2));
		    }
else {
    if (files_selected!=0) {
	    gtk_clist_get_text(GTK_CLIST(clist1),last_select_row--,1,&text);
	    if (fork()==0) execl("/tmp/grarview","grarview",rar_path,pass_command,name,text,NULL);
	    wait(0);
	    viewfile=fopen("/tmp/.view","r");
	    fseek(viewfile,0L,SEEK_END);
	    viewsize=ftell(viewfile);
	    vwfile=malloc(viewsize);
	    fseek(viewfile,0L,SEEK_SET);
	    fread(vwfile,viewsize,1,viewfile);
	    fclose(viewfile);
	    window1=create_window1();
	    gtk_widget_show(window1);
	    gtk_text_freeze(GTK_TEXT(text2));
	    q=0;
	    while (vwfile[q]!='-' || vwfile[q+1]!='-') q++;
	    q+=16;
	    gtk_text_insert(GTK_TEXT(text2),NULL,&text2->style->black,NULL,vwfile+q,viewsize-q);
	    gtk_text_thaw(GTK_TEXT(text2));
	    remove("/tmp/.view");
	    gtk_clist_unselect_row(GTK_CLIST(clist1),last_select_row,0);
	    files_selected=0;
	}
}
}


void
on_repair_archive1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_test_archive1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_add_comment1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
read_pwd_files(char *pwd)
{
gchar *tempvar;
int line=0;
int q=0,p=0,z=0,b=0;
//gchar *text1;
//gchar *text2;
//gchar *text3;
p=2;
getcwd(cur_dir,0x100);
gtk_entry_set_text((GtkEntry *)entry6,cur_dir);
open_xpm("dir.xpm",clist1,&dirpix,&dirmask,1);
open_xpm("doc.xpm",clist1,&docpix,&docpix,1);
open_xpm("comp.xpm",clist1,&comppix,&compmask,1);
open_xpm("dotdot.xpm",clist1,&dotpix,&dotmask,1);
open_xpm("locked.xpm",clist1,&lockpix,&lockmask,1);
reading=opendir(pwd);
gtk_clist_freeze((GtkCList *) clist1);
while((next=readdir(reading))!=NULL) {
					if (line!=0 && line!=1) {
									stat((char *)next->d_name,&statbuf);
									xfer_mode(attr);
									if (attr[0]=='d') (gchar*)clist_line1[line][2]="dir";
									else (gchar*)clist_line1[line][2]=0;
								}
					(gchar*)clist_line1[line][1]=(char *)next->d_name;
					line++;
					}
(gchar *)clist_line1[0][1]=".";
(gchar *)clist_line1[1][1]="..";
gtk_clist_insert((GtkCList *)clist1,0,clist_line1[0]);
gtk_clist_insert((GtkCList *)clist1,1,clist_line1[1]);
gtk_clist_set_pixmap((GtkCList *)clist1,1,0,dotpix,dotmask);
//some sort of alpha sort for handling dirs
tempvar=(gchar *)"zzzzzzz";
q=2;
while (q<line) {
	for (p=2;p<line;p++) {
	    if ((strcmp(tempvar,clist_line1[p][1])>0) && (clist_line1[p][2]=="dir") && ((test_inserted(q,clist_line1[p][1]))==0) )
	    {
		z=p;
		tempvar=clist_line1[p][1];
	    }
	}
	if (z!=0) {
		    stat((char *)clist_line1[z][1],&statbuf);
		    g_snprintf(buff,50,"%-10ld",statbuf.st_size);
		    (gchar*)clist_line1[z][3]=(gchar *)buff;
		    (gchar*)clist_line1[z][5]=ctime(&statbuf.st_atime);
		    xfer_mode(attr);
		    (gchar*)clist_line1[z][6]=(gchar*)attr;
		    gtk_clist_insert((GtkCList *)clist1,q,clist_line1[z]);
		    gtk_clist_set_pixmap(GTK_CLIST(clist1),q,0,dirpix,dirmask);
		    b++;z=0;
		    }
	q++;tempvar=(gchar *)"zzzzzzz";
}
//some sort of alpha sort for handling files&symlnks
tempvar=(gchar *)"zzzzz";
q=2;z=0;
while (q<line) {
	for (p=2;p<line;p++) {
	    if ((strcmp(tempvar,clist_line1[p][1])>0) && (clist_line1[p][2]!="dir") && ((test_inserted(b+q,clist_line1[p][1]))==0) )
	    {
		z=p;
		tempvar=clist_line1[p][1];
	    }
	}
	if (z!=0 && b+q!=0) {
		    stat((char *)clist_line1[z][1],&statbuf);
		    g_snprintf(buff,50,"%-10ld",statbuf.st_size);
		    (gchar*)clist_line1[z][3]=(gchar *)buff;
		    (gchar*)clist_line1[z][5]=ctime(&statbuf.st_atime);
		    xfer_mode(attr);
		    (gchar*)clist_line1[z][6]=(gchar*)attr;
		    gtk_clist_insert((GtkCList *)clist1,b+q,clist_line1[z]);
		    gtk_clist_set_pixmap(GTK_CLIST(clist1),b+q,0,docpix,docmask);
		    z=0;
		    }
	q++;tempvar=(gchar *)"zzzzz";
}

sel_files=malloc(0xFF*(line+2)+0xFF+line);
gtk_clist_thaw((GtkCList *) clist1);

j=0;
files_selected=0;
}

int
test_inserted(int list_size,gchar *myword)
{
int is_inserted=0;
int i;
gchar *text;
for (i=0;i<list_size;i++) {
			    gtk_clist_get_text(GTK_CLIST(clist1),i,1,&text);
			    if (strcmp(text,myword)==0) is_inserted=1;
			    }
return is_inserted;
}

int
cmpare(gchar *s1,gchar *s2)
{
int mycmp=-1;
int vfon=0;
while (s1[pos1]!='\0'){
			if (s1[pos1]==s2[pos2]) { pos1++;pos2++;vfon=1;}
			else {if (vfon==0) {
					    pos1++;
					    pos2=0;
					}
				if (vfon==1) {
						pos1++;
						vfon=0;
						}
				}
			if (s2[pos2]=='\0') {endpos=pos1;mycmp=0;}
			}
pos1=0;
pos2=0;
return mycmp;
}

void
on_button10_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
if (opd_archive!=0){
		    open4=create_fileselection3();
		    gtk_widget_show(open4);
		    }
else{
	if (rar_ok==0) {
		messagebox4=create_messagebox4();
		gtk_widget_show(messagebox4);
		}
	else if (fork()==0) execl(rar_path,"rar","t",name,0);
	}
}


void
on_ok_button3_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
test_arch_name=gtk_file_selection_get_filename (GTK_FILE_SELECTION(user_data));
strcpy(nicexfr,test_arch_name);
g_print("%s",test_arch_name);
gtk_widget_destroy(open4);
if (rar_ok==0) {
		messagebox4=create_messagebox4();
		gtk_widget_show(messagebox4);
		}
if (fork()==0) execl(rar_path,"rar","t",nicexfr,0);
/*
reload_arch(nicexfr);
memcpy((gchar *)name,nicexfr,0x100);
opd_archive=0;
sel_files=malloc(0xFF*(line+2)+0xFF+line);
strcpy(sel_files,(gchar *)name);
g_snprintf(buff,50,"Total files: %d",line);
gtk_statusbar_push(GTK_STATUSBAR(statusbar1),context_id,buff);
fbuffer[0]=0;
j=0;
j=j+strlen((gchar *)name);sel_files[j]=0x20;sel_files[j++]=0x20;
implicit_sel=j;
*/
messagebox6=create_messagebox6();
gtk_widget_show(messagebox6);
}



void
on_cancel_button3_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(open4);
}

void
on_fileselection3_destroy              (GtkObject       *object,
                                        gpointer         user_data)
{
gtk_widget_destroy(open4);
}


void
on_dialog3_show                   (GtkWidget       *widget,
                            	   gpointer         user_data)
{
text1=user_data;
if (rar_ok==0) {
		g_snprintf(buff,50,"rar not found in : %s",rar_path);
		gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
		}
else if (opd_archive==0){
		    if (fork()==0) execl(rar_path,"rar","-o+","-y","cw",name,".comm",0);
		    wait(0);
		    if ((commfile=fopen(".comm","r"))!=0){
				    fseek(commfile,0L,SEEK_END);
				    commsize=ftell(commfile);
				    cmmfile=malloc(commsize);
				    fseek(commfile,0L,SEEK_SET);
				    fread(cmmfile,commsize,1,commfile);
				    fclose(commfile);
				    textlen=gtk_text_get_length(GTK_TEXT(text1));
				    gtk_text_backward_delete(GTK_TEXT(text1),textlen);
				    gtk_text_freeze(GTK_TEXT(text1));
				    gtk_text_insert(GTK_TEXT(text1),NULL,&text1->style->black,NULL,cmmfile,commsize);
				    gtk_text_thaw(GTK_TEXT(text1));
				    textlen=gtk_text_get_length((GtkText *)text1);
				    remove(".comm");
				    free(cmmfile);
				}
		}
}


void
on_button19_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
if (rar_ok==0) {
		messagebox4=create_messagebox4();
		gtk_widget_show(messagebox4);
		}
else if (opd_archive==0) {
    if ((textlen=gtk_text_get_length(GTK_TEXT(text1)))!=0){
		mygtktext=gtk_editable_get_chars((GtkEditable *)text1,0,textlen);
		commfile=fopen(".comm","w+");
		fwrite(mygtktext,textlen,1,commfile);
		fclose(commfile);
		if(fork()==0) execl(rar_path,"rar","-o+","-y","c","-z.comm",name,0);
		wait(0);
		remove(".comm");
		}
    else{
	if(fork()==0) execl(rar_path,"rar","-o+","-y","c","-z/dev/null",name,0);
	wait(0);
    }
}
}


void
on_button20_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
textlen=gtk_text_get_length((GtkText *)text1);
gtk_text_backward_delete(GTK_TEXT(text1),textlen);
}

void
xfer_mode(char *mode)
{
(void)strcpy(mode,"----------");
if(statbuf.st_mode & (S_IEXEC>>6)) mode[9]='x';
if(statbuf.st_mode & (S_IWRITE>>6)) mode[8]='w';
if(statbuf.st_mode & (S_IREAD>>6)) mode[7]='r';
if(statbuf.st_mode & (S_IEXEC>>3)) mode[6]='x';
if(statbuf.st_mode & (S_IWRITE>>3)) mode[5]='w';
if(statbuf.st_mode & (S_IREAD>>3)) mode[4]='r';
if(statbuf.st_mode & S_IEXEC) mode[3]='x';
if(statbuf.st_mode & S_IWRITE) mode[2]='w';
if(statbuf.st_mode & S_IREAD) mode[1]='r';
if(statbuf.st_mode & S_ISVTX) mode[9]='t';		/* Sticky bit */
if(statbuf.st_mode & S_ISGID) mode[6]='s';		/* Set grup id */
if(statbuf.st_mode & S_ISUID) mode[3]='s';		/* Set user id */
switch(statbuf.st_mode & S_IFMT){
case S_IFDIR:mode[0]='d';break;
case S_IFCHR:mode[0]='c';break;
case S_IFBLK:mode[0]='b';break;
case S_IFREG:mode[0]='-';break;
default	    :mode[0]='?';
}
}


void
on_optionmenu2_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
//g_print("%s",user_data);
}


void
on_button7_enter                       (GtkButton       *button,
                                        gpointer         user_data)
{
g_snprintf(buff,50,"Create/Add files to archive");
gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
}


void
on_button7_leave                       (GtkButton       *button,
                                        gpointer         user_data)
{
gnome_appbar_pop(GNOME_APPBAR(statusbar1));
}

void
on_button8_enter                       (GtkButton       *button,
                                        gpointer         user_data)
{
g_snprintf(buff,50,"Open archive");
gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
}


void
on_button8_leave                       (GtkButton       *button,
                                        gpointer         user_data)
{
gnome_appbar_pop(GNOME_APPBAR(statusbar1));
}


void
on_button9_enter                       (GtkButton       *button,
                                        gpointer         user_data)
{
g_snprintf(buff,50,"Extract files from archive to current path");
gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
}


void
on_button9_leave                       (GtkButton       *button,
                                        gpointer         user_data)
{
gnome_appbar_pop(GNOME_APPBAR(statusbar1));
}


void
on_button10_enter                      (GtkButton       *button,
                                        gpointer         user_data)
{
g_snprintf(buff,50,"Test archive integrity");
gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
}


void
on_button10_leave                      (GtkButton       *button,
                                        gpointer         user_data)
{
gnome_appbar_pop(GNOME_APPBAR(statusbar1));
}


void
on_button11_enter                      (GtkButton       *button,
                                        gpointer         user_data)
{
g_snprintf(buff,50,"View selected file");
gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
}


void
on_button11_leave                      (GtkButton       *button,
                                        gpointer         user_data)
{
gnome_appbar_pop(GNOME_APPBAR(statusbar1));
}


void
on_button12_enter                      (GtkButton       *button,
                                        gpointer         user_data)
{
g_snprintf(buff,50,"Delete selected files from archive");
gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
}


void
on_button12_leave                      (GtkButton       *button,
                                        gpointer         user_data)
{
gnome_appbar_pop(GNOME_APPBAR(statusbar1));
}


void
on_button17_enter                      (GtkButton       *button,
                                        gpointer         user_data)
{
g_snprintf(buff,0x50,"Archive options: Add/Remove Comments, Convert to SFX, Put auth info");
gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
}


void
on_button17_leave                      (GtkButton       *button,
                                        gpointer         user_data)
{
gnome_appbar_pop(GNOME_APPBAR(statusbar1));
}


void
on_button18_enter                      (GtkButton       *button,
                                        gpointer         user_data)
{
g_snprintf(buff,50,"GnomeRAR help");
gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
}


void
on_button18_leave                      (GtkButton       *button,
                                        gpointer         user_data)
{
gnome_appbar_pop(GNOME_APPBAR(statusbar1));
}


void
on_button13_enter                      (GtkButton       *button,
                                        gpointer         user_data)
{
g_snprintf(buff,50,"Quit GnomeRAR");
gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
}


void
on_button13_leave                      (GtkButton       *button,
                                        gpointer         user_data)
{
gnome_appbar_pop(GNOME_APPBAR(statusbar1));
}


void
on_propertybox1_apply                  (GnomePropertyBox *gnomepropertybox,
                                        gint             arg1,
                                        gpointer         user_data)
{
g_print("shhhhoapte");
}


void
on_button31_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(dialog3);
}


void
on_button32_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gchar sfxname[0x100];
FILE *sfx,*dsfx;
int sfxsize;
char *sfxfile;
p=0;
if (applych==1 || opd_archive==0){
		if (convsfx==1) {
				strcpy(sfxname,(gchar *)name);
				while (sfxname[p]!='.') {
							p++;
							}
				sfxname[p]='\0';
				sfx=fopen(sfxname,"w+");
				strcpy(sfx_path,def_path);
				strcat(sfx_path,"/default.sfx");
				if ((dsfx=fopen(sfx_path,"r"))==0) g_print("%s - not found",sfx_path);
				fseek(dsfx,0L,SEEK_END);
				sfxsize=ftell(dsfx);
				sfxfile=malloc(sfxsize);
				fseek(dsfx,0L,SEEK_SET);
				fread(sfxfile,sfxsize,1,dsfx);
				fclose(dsfx);
				fwrite(sfxfile,sfxsize,1,sfx);
				free(sfxfile);
				if ((dsfx=fopen((char *)name,"r"))==0) g_print("Archive file - not found");
				fseek(dsfx,0L,SEEK_END);
				sfxsize=ftell(dsfx);
				sfxfile=malloc(sfxsize);
				fseek(dsfx,0L,SEEK_SET);
				fread(sfxfile,sfxsize,1,dsfx);
				fclose(dsfx);
				fwrite(sfxfile,sfxsize,1,sfx);
				free(sfxfile);
				fclose(sfx);
				if (fork()==0) execl("/bin/chmod","chmod","u+x",sfxname,0);
				g_snprintf(buff,90,"Archive %s converted to SFX. Written %s as binary file.",(char *)name,sfxname);
				gnome_appbar_push(GNOME_APPBAR(statusbar1),buff);
				}
		if (pathch==1) {
				rar_path1=gtk_entry_get_text(GTK_ENTRY(entry3));
				cfgfile=fopen(my_path,"w");
				fwrite(rar_path1,strlen(rar_path1),1,cfgfile);
				fclose(cfgfile);
				strcpy(def_path,(gchar *)rar_path1);
				strcpy(rar_path,(gchar *)rar_path1);
				strcat(rar_path,"/rar");
				rar_ok=check_for_rar();
				}
		}
}


void
on_button33_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(dialog3);
}


void
on_dialog3_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
gtk_widget_destroy(dialog3);
}


void
on_checkbutton14_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
convsfx=1;
applych=1;
}

void open_xpm (char *filename, GtkWidget *parent, GdkPixmap **pixmap, GdkBitmap **mask, int quit_on_err) {
   char  *temp1str;
   GtkStyle *style;

   if (*filename == '\0') return;
   style = gtk_widget_get_style (parent);
   temp1str = g_strconcat (BASE_CONF_DIR, "/", filename, NULL);
   /*expand_path (temp1str, tempstr, sizeof (tempstr));
   if (access (tempstr, F_OK) != 0) {
      g_free (temp1str);
      temp1str = g_strconcat (SHARE_DIR, "/", filename, NULL);
      //expand_path (temp1str, tempstr, sizeof (tempstr));
      if (access (tempstr, F_OK) != 0) {
         g_free (temp1str);
         temp1str = g_strconcat ("/usr/share/icons/", filename, NULL);
         //expand_path (temp1str, tempstr, sizeof (tempstr));
         if (access (tempstr, F_OK) != 0) {
            g_free (temp1str);
            if (!quit_on_err) return;
            printf ("Error: Cannot find file %s in %s or %s\n", filename, SHARE_DIR, BASE_CONF_DIR);
            exit (-1);
         }
      }
   }*/
   *pixmap = gdk_pixmap_create_from_xpm (parent->window, mask, &style->bg[GTK_STATE_NORMAL], temp1str);
   if (*pixmap == NULL) {
      g_free (temp1str);
      if (!quit_on_err) return;
      printf("Error: Error opening file %s\n", temp1str);
      exit (-1);
   }
   g_free (temp1str);
}

void
on_entry3_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
applych=1;
pathch=1;
}


void
on_combo_entry1_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
vol_size=gtk_entry_get_text((GtkEntry *)editable);
vol_change=1;
}



void
on_radiobutton1_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
GList *glist=NULL;
combo1=user_data;
glist=g_list_append(glist,"362400");
glist=g_list_append(glist,"730000");
glist=g_list_append(glist,"1213800");
glist=g_list_append(glist,"1457500");
glist=g_list_append(glist,"2915200");
glist=g_list_append(glist,"Autodetect");
gtk_combo_set_popdown_strings(GTK_COMBO(combo1),glist);
}


void
on_radiobutton2_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
GList *glist=NULL;
combo1=user_data;
glist=g_list_append(glist,"360k - disk");
glist=g_list_append(glist,"720k - disk");
glist=g_list_append(glist,"1,2M - disk");
glist=g_list_append(glist,"1,44M - disk");
glist=g_list_append(glist,"2,88M - disk");
glist=g_list_append(glist,"Autodetect size of curent drive");
gtk_combo_set_popdown_strings(GTK_COMBO(combo1),glist);
}


void
on_combo_entry2_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
compression_level=gtk_entry_get_text((GtkEntry *)editable);
strcpy(comp_command,"-m");
if (strcmp(compression_level,"Store")==0) strcat(comp_command,"0");
if (strcmp(compression_level,"Fastest")==0) strcat(comp_command,"1");
if (strcmp(compression_level,"Fast")==0) strcat(comp_command,"2");
if (strcmp(compression_level,"Normal")==0) strcat(comp_command,"3");
if (strcmp(compression_level,"Good")==0) strcat(comp_command,"4");
if (strcmp(compression_level,"Best")==0) strcat(comp_command,"5");
}


void
on_combo_entry3_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
dictionary_size=gtk_entry_get_text((GtkEntry *)editable);
strcpy(dict_command,"-md");
strcat(dict_command,(gchar *)dictionary_size);
dict_command[strlen(dict_command)-1]='\0';
}


void
on_entry4_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
create_arch_pass=gtk_entry_get_text((GtkEntry *)editable);
create_locked_arch=1;
strcpy(pass_command,"-p");
strcat(pass_command,(gchar *)create_arch_pass);
g_print("%s",pass_command);
}


void
on_entry5_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
arch_pass=gtk_entry_get_text((GtkEntry *)editable);
strcpy(pass_command,"-p");
strcat(pass_command,(gchar *)arch_pass);
}


void
on_window2_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
gtk_widget_destroy(window2);
}


void
on_button37_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(window2);
}


void
on_button38_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(window2);
}

void
config_path(void)
{
struct passwd *pw;
pw=getpwuid(getuid());
strcpy(my_path,pw->pw_dir);
strcat(my_path,"/.gnomerar");
}

gboolean
on_clist1_button_press_event           (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
gchar *text;
if (event->type==GDK_2BUTTON_PRESS) {
				    if (row!=0 || row!=1) {
					gtk_clist_get_text(GTK_CLIST(widget),last_select_row,1,&text);
					chdir(text);
					gtk_clist_freeze((GtkCList *) widget);
					gtk_clist_clear( (GtkCList *) widget);
					read_pwd_files(".");
					gtk_clist_thaw((GtkCList *) widget);
					last_select_row=0;
					files_selected=0;
					total_sel_size=0;
					testdbl=1;
				    }
				}
  return FALSE;
}


void
on_combo_entry4_activate               (GtkEditable     *editable,
                                        gpointer         user_data)
{
gchar *text;
text=gtk_entry_get_text((GtkEntry *)editable);
chdir(text);
gtk_clist_clear( (GtkCList *) clist1);
read_pwd_files(".");
}

